/*
 * L.CircleMarker is a circle overlay with a permanent pixel radius. 
 */

L.CircleMarker = L.Circle.extend({
	options: {
		radius: 10,
		weight: 2
	},
	
	initialize: function(latlng, options) {
		L.Circle.prototype.initialize.call(this, latlng, null, options);
		this._radius = this.options.radius;
	},
	
	projectLatlngs: function() {
		this._point = this._map.latLngToLayerPoint(this._latlng);
	},
	
	setRadius: function(radius) {
		this._radius = radius;
		this._redraw();
		return this;
	}	
});